/* Copyright (c) 2011 Asustor Inc. All rights reserved. */

Ext.ns('ISIDEV.apps.etherwake');

/**
 * @class ISIDEV.apps.etherwake.core
 * @extends Ext.util.Observable
 * <p>core</p>
 */
Ext.define('ISIDEV.apps.etherwake.core', {
	extend: 'Ext.util.Observable',
	
	constructor: function (config) {
		Ext.apply(this, config);
		
		this.callParent();
		
		this.init();
	},
	
	init: function () {
		var fn = this;

		fn.win = fn.desktop.createWindow({
			app: fn.app,
			id: fn.id,
			itemId: fn.id,
			width: 610,
			height: 460,
			resizable: false,
			border: false,
			layout: 'border',
			bodyStyle: 'padding: 0; border: none; background: #FFFFFF;',
			items: [
				fn.getMainPanel()
			],
			listeners: {
				afterrender: function (win) {
					win.header.items.items[1].hide();
				}
			}
		});
	},
	getMainPanel:function(){
		
		var hostip=document.location.href.match(/^.*:\/\/(.*):/)[1];
	
		var panel=Ext.create("Ext.panel.Panel",{
			html:'<iframe style="" frameborder="0" width="100%" height="100%" src="http://'+hostip+':9876" />',
			width:600,
			height:450,
			region: 'center',
		});
		return panel;
	},

});

/**
 * @class ISIDEV.apps.etherwake.main
 * @extends AS.ARC._appBase
 * <p>Main app</p>
 */
Ext.define('ISIDEV.apps.etherwake.main', {
	extend: 'AS.ARC._appBase',

	appTag: 'etherwake',
	title: 'Etherwake',
	appMaxNum: 1,
	appOpenNum: 0,
	appIsReady: true,
	appWins: [],
	
	createWindow: function () {
	
		var desktop = this.core.getDesktop(),			
			app = this;
		
		if ((this.appOpenNum === this.appMaxNum) || !this.appIsReady) {
			this.appWins[0].show();
			return;
		}
		
		// Set appIsReady to false
		this.appIsReady = false;

		var etherwake = new ISIDEV.apps.etherwake.core({
			app: this,
			desktop: desktop,
			id: this.id + '-' + Ext.id()
		});
		
		etherwake.win.on('render', function () {
			app.appOpenNum++;
			app.appIsReady = true;
		});		
	
		etherwake.win.on('beforeclose', function () {
			app.appOpenNum--;
			app.appIsReady = true;
			app.appWins.pop();
		});		
		etherwake.win.show();
		
		// Get all wins for handling
		this.appWins.push(etherwake.win);
	}
});